// vim: fileencoding=utf-8
// content script space
(function(){
  if(window !== window.parent) return;

  var connection = chrome.extension.connect({name : 'TBRL'});
  var lid = 0;
  var TBRL = {
    target : null,
    init : function(){
      // 確認
      alert(document.title);
      document.addEventListener('keydown', TBRL.keyhandler, false);
      document.addEventListener('mousemove', TBRL.mousehandler, false);
      document.addEventListener('unload', TBRL.unload, false);
      connection.onMessage.addListener(function(item){
        var type = item.type;
        if(type === 'request'){
          request_handler(item);
        } else if(type === 'post'){
          post_handler(item);
        }
      });
    },
    unload : function(){
      document.removeEventListener('unload', TBRL.unload, false);
      document.removeEventListener('keydown', TBRL.handler, false);
      document.removeEventListener('mousemove', TBRL.mousehandler, false);
    },
    keyhandler : function(ev){
      var id = ev.keyIdentifier;
      var t = ev.target;
      if(t.nodeType === 1){
        var tag = t.tagName.toLowerCase();
        if(tag === 'input' || tag === 'textarea'){
          return;
        }
        // alt + z
        if(id === "U+005A" && (ev.metaKey || ev.altKey) && !ev.shiftKey && !ev.ctrlKey){
          return request(location.href).addCallback(function(res){
            var doc = createHTML(res.responseText);
          });
          /*
          console.log('ALT Z');
          var context = update({
            document :document,
            window : window,
            title : document.title,
            selection : ''+window.getSelection(),
            target : TBRL.target || document,
          }, window.location);
          var exts = Extractors.check(context);
          if(exts.length){
            exts[0].extract(context)
            .addCallback(function(res){
              return post(res);
            });
          }
          */
        }
      }
    },
    mousehandler : function(ev){
      // 監視
      TBRL.target = ev.target;
    }
  }
  TBRL.init();

  Callbacks = {};
  var request = (function(){
    var ID = 0;
    return function(url, opt){
      var id = "request_"+(++ID);
      var ret = Callbacks[id] = new Deferred();
      connection.postMessage({
        "type" : "request",
        "url" : url,
        "opt" : opt,
        "id" : id
      });
      return ret;
    }
  })();
  var request_handler = function(item){
    var d = Callbacks[item.id];
    if(d){
      delete Callbacks[item.id];
      var suc = item.success;
      if(suc){
        d.callback(item.res);
      } else {
        d.errback(item.res);
      }
    }
  }
  var post = (function(){
    var ID = 0;
    return function(ps){
      var id = "post_"+(++ID);
      var ret = Callbacks[id] = new Deferred();
      connection.postMessage({
        "type" : "post",
        "ps" : ps,
        "id" : id
      });
      return ret;
    }
  })();
  var post_handler = function(item){
    var d = Callbacks[item.id];
    if(d){
      delete Callbacks[item.id];
      var suc = item.success;
      if(suc){
        d.callback(item.res);
      } else {
        d.errback(item.res);
      }
    }
  }
})();
