// vim: fileencoding=utf-8

//
// from ChromeFullFeed http://code.google.com/p/chromefullfeed/
// MIT licence
//
function createHTML(str) {
  // iframeは必要
  //str = str.replace(/<script(?:[ \t\r\n][^>]*)?>[\S\s]*?<\/script[ \t\r\n]*>|<\/?(?:html|script|object)(?:[ \t\r\n][^<>]*)?>/gi, ' ');
  var htmldoc = document.implementation.createHTMLDocument('CREATEDBYTABERARELOO');
  var range = document.createRange();
  range.selectNodeContents(document.body);
  alert('BEFORE CREATEHTML + CONTEXUALFRAGMENT');
  htmldoc.body.appendChild(range.createContextualFragment(str));
  alert('AFTER  CREATEHTML + CONTEXUALFRAGMENT');
  return htmldoc;
}

function creatXML(str){
  var xhr = new XMLHttpRequest();
  xhr.open("GET", str, false);
  xhr.send(null);
  return xhr.responseXML;
}

// XPath 式中の接頭辞のない名前テストに接頭辞 prefix を追加する
// e.g. '//body[@class = "foo"]/p' -> '//prefix:body[@class = "foo"]/prefix:p'
// http://nanto.asablo.jp/blog/2008/12/11/4003371
function addDefaultPrefix(xpath, prefix) {
	var tokenPattern = /([A-Za-z_\u00c0-\ufffd][\w\-.\u00b7-\ufffd]*|\*)\s*(::?|\()?|(".*?"|'.*?'|\d+(?:\.\d*)?|\.(?:\.|\d+)?|[\)\]])|(\/\/?|!=|[<>]=?|[\(\[|,=+-])|([@$])/g;
	var TERM = 1, OPERATOR = 2, MODIFIER = 3;
	var tokenType = OPERATOR;
	prefix += ':';
	function replacer(token, identifier, suffix, term, operator, modifier) {
		if (suffix) {
			tokenType =
				(suffix == ':' || (suffix == '::' && (identifier == 'attribute' || identifier == 'namespace')))
				? MODIFIER : OPERATOR;
		} else if (identifier) {
			if (tokenType == OPERATOR && identifier != '*')
				token = prefix + token;
			tokenType = (tokenType == TERM) ? OPERATOR : TERM;
		} else {
			tokenType = term ? TERM : operator ? OPERATOR : MODIFIER;
		}
		return token;
	}
	return xpath.replace(tokenPattern, replacer);
}

// $X on XHTML
// $X(exp);
// $X(exp, context);
// @target Freifox3, Chrome3, Safari4, Opera10
// @source http://gist.github.com/184276.txt
function $X (exp, context) {
	context || (context = document);
	var _document  = context.ownerDocument || document,
	documentElement = _document.documentElement;
	var isXHTML = documentElement.tagName !== 'HTML' && _document.createElement('p').tagName === 'p';
	var defaultPrefix = null;
	if (isXHTML) {
		defaultPrefix = '__default__';
		exp = addDefaultPrefix(exp, defaultPrefix);
	}
	function resolver (prefix) {
		return context.lookupNamespaceURI(prefix === defaultPrefix ? null : prefix) ||
			   documentElement.namespaceURI || '';
	}

	var result = _document.evaluate(exp, context, resolver, XPathResult.ANY_TYPE, null);
		switch (result.resultType) {
			case XPathResult.STRING_TYPE : return result.stringValue;
			case XPathResult.NUMBER_TYPE : return result.numberValue;
			case XPathResult.BOOLEAN_TYPE: return result.booleanValue;
			case XPathResult.UNORDERED_NODE_ITERATOR_TYPE:
				// not ensure the order.
				var ret = [], i = null;
				while (i = result.iterateNext()) ret.push(i);
				return ret;
		}
	return null;
}

// Ported from Tombloo
// Public License
function joinText(txts, delm, trimTag){
  if(!txts) return '';
  if(delm==null) delm = ',';
  txts = [].concat(txts).filter(operator.truth).flatten();
  return (trimTag? txts.map(methodcaller('trimTag')) : txts).join(delm);
}

function unescapeHTML(s){
  return s.replace(/&amp;/g, '&')
    .replace(/&quot;/g, '"')
    .replace(/&lt;/g, '<')
    .replace(/&gt;/g, '>');
}

function update(t, s){
  for(var p in s) t[p] = s[p];
  return t;
}

function formContents(elm){
  if(typeof(elm) === 'string') elm = createHTML(elm);
  var form = MochiKit.DOM.formContents(elm);
  var ret = {};
  zip(form[0], form[1]).forEach(function(arr){
    var name = arr[0];
    var val = arr[1];
    if(ret[name]){
      if(ret[name] instanceof Array){
        ret[name].push(val);
      } else {
        ret[name] = [ret[name], val];
      }
    } else {
      ret[name] = val;
    }
  });
  return ret;
}

function $A(arr){
  return Array.prototype.slice.call(arr);
};

var $ = (function(){
  var hash = {};
  return function(id){
    return hash[id] || document.getElementById(id);
  }
})();

var $DF = function(){
  return document.createDocumentFragment();
}

var $N = function(name, attr, childs){
	var ret = document.createElement(name);
  if(attr) for (var k in attr) if (attr.hasOwnProperty(k)) {
    ret.setAttribute(((k === "class")? 'className' : k), attr[k]);
	}
  console.log(attr);
	switch(typeof childs){
	  case "string":
		ret.appendChild(document.createTextNode(childs));
		break;
	  case "object":
		for(var i=0, len=childs.length; i<len; i++){
			var child = childs[i];
			if(typeof child == "string"){
				ret.appendChild(document.createTextNode(child));
			} else {
				ret.appendChild(child);
			}
		}
	}
	return ret;
};

var $T = function(mes){
  return document.createTextNode(mes);
};

function DeferredHash(ds){
  var props = keys(ds);
  return new DeferredList(values(ds)).addCallback(function(results){
    var res = {};
    for (var i = 0, len=results.length; i < len; i++)
      res[props[i]] = results[i];
    return res;
  });
}

// like tombloo Repository
var Repository = function(){
  this.list = [];
}
Repository.prototype = {
  size : function(){
    return this.values().length;
  },
  names : function(){
    return this.values().map(itemgetter('name'));
  },
  values : function(){
    return this.list.filter(function(i){ return i.name });
  },
  clear : function(){
    this.names().forEach(function(name){
      delete this[name];
    }, this);
    this.list = [];
  },
  find : function(name){
    return this.values().filter(function(i){
      return !!~i.name.search(name);
    });
  },
  copyTo : function(t){
    t.list = $A(this.list);
    t.list.forEach(function(def){
      t[def.name] = def;
    });
    return t;
  },
  check : function(){
    var args = arguments;
    return this.values().reduce(function(memo, i){
      if(i.check && i.check.apply(i, args)) memo.push(i);
      return memo;
    }, []);
  },
  register : function(defs, target, after){
    if(!defs) return;
    defs = [].concat(defs);
    if(target){
      var vals = this.values();
      this.clear();
      for(var i = 0, len = vals.length; i < len; ++i){
        if(vals[i].name == target) break;
      }
      vals.splice((after? i+1 : i), 0).concat(defs);
      defs = vals;
    }
    defs.forEach(function(d){
      this.list.push(d);
      this[d.name] = d;
    }, this);
  }
}

